<template>
  <div>
    <router-view/>
    <div id="tab-bar">
      <div class="tab-bar-item" v-for="i in [0,1]" :key="i" @click="switchTab(i)">
        <div v-if="i===selected" class="icon" :style='`background-image: url("${tabBarItems[i].iconChosen}");`'></div>
        <div v-else class="icon" :style='`background-image: url("${tabBarItems[i].icon}");`'></div>
        <span class="label">{{tabBarItems[i].label}}</span>
      </div>
      <router-link to="/upload">
        <div class="add-button">+</div>
      </router-link>
      <div class="tab-bar-item" @click="switchTab(2)">
        <div v-if="2===selected" class="icon" :style='`background-image: url("${tabBarItems[2].iconChosen}");`'>
          <div class="dot" v-if="newMessage"></div>
        </div>
        <div v-else class="icon" :style='`background-image: url("${tabBarItems[2].icon}");`'>
          <div class="dot" v-if="newMessage"></div>
        </div>
        <span class="label"> {{tabBarItems[2].label}} </span>
      </div>
      <div class="tab-bar-item" @click="switchTab(3)">
        <div v-if="3===selected" class="icon" :style='`background-image: url("${tabBarItems[3].iconChosen}");`'></div>
        <div v-else class="icon" :style='`background-image: url("${tabBarItems[3].icon}");`'></div>
        <span class="label"> {{tabBarItems[3].label}} </span>
      </div>
    </div>
  </div>
</template>

<script>
import tabBarConfig from '@/components/TabBarConfig'

export default {
  name: 'TabBarView',
  data () {
    return {
      tabBarItems: tabBarConfig
    }
  },
  computed: {
    selected () {
      return this.$store.state.tabBar.index
    },
    newMessage () {
      return this.$store.state.tabBar.newMessage
    }
  },
  methods: {
    switchTab (index) {
      if (index === this.selected) return
      this.$router.replace(tabBarConfig[index].path)
    }
  },
  beforeRouteEnter (to, from, next) {
    next(vm => {
      let toIndex = tabBarConfig.findIndex(item => item.path === to.matched[1].path)
      if (toIndex !== -1) {
        vm.$store.commit('tabBar/switchTab', toIndex)
      }
    })
  },
  beforeRouteUpdate (to, from, next) {
    let toIndex = tabBarConfig.findIndex(item => item.path === to.matched[1].path)
    if (toIndex !== -1) {
      this.$store.commit('tabBar/switchTab', toIndex)
    }
    next()
  },
  mounted () {
  }
}
</script>

<style scoped lang="less">
#tab-bar {
  position: fixed;
  bottom: 0;
  left: 0;
  right: 0;
  height: var(--tab-bar-height);

  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: space-between;
  padding: 0 28.5px;

  background-color: white;
  .tab-bar-item {
    display: flex;
    flex-direction: column;
    align-items: center;

    .icon {
      position: relative;
      width: 18.97px;
      height: 18.97px;
      background-size: contain;
      background-repeat: no-repeat;
      background-position: center center;
      margin-block-end: 4px;
      .dot {
        width: 7.1px;
        height: 7.5px;
        position: absolute;
        border-radius: 50%;
        right: -3px;
        top: -2px;
        background-color: #EF4C4C;
      }
    }
    .label {
      font-size: 11px;
      color: #969696;
      text-align: right;
    }
  }
  .add-button {
    height: var(--tab-bar-height);
    width: var(--tab-bar-height);
    border-radius: 5px;
    font-size: 30px;
    font-weight: 900;
    color: white;
    vertical-align: center;
    text-align: center;
    background-color: #3170FF;
  }
}
</style>
